@inject Backend back
@inject Observatory obz
@inject Waiter wagter
@implements IDisposable

<div class="custom-scroller" style="height: 100%; width: 100%;">
<div class="card shadow" style="padding: 24px; overflow-y: auto; height: 100%; width: 100%;">
    @if (Hand == null) {
        <p style="text-align: center;">Loading hand...</p>
    }else{
        <div class="d-flex" style="flex-wrap: wrap;">
            @foreach(ResponseCard card in Hand){
                <div class="card shadow-sm cah-card" style="margin-right: 8px; margin-bottom: 8px; background-color: @getCardBGCol(card.card_id);"
                    onmouseleave="document.getElementById('btn-'+'@card.GetElID()').style['display']='none'" 
                    onmouseover="document.getElementById('btn-'+'@card.GetElID()').style['display']='block'">
                    <div class="d-flex" style="flex-direction: column; height: 100%;">
                        <div>@card.card_text</div>
                        <div style="flex-grow: 1"></div>
                        <div style="display: none; margin: auto;" id="btn-@card.GetElID()">
                            @if (!hasPlayed){
                                <SpinButton OnClickCallback="()=>OnCardClick(card.card_id)" SpinningKey="awaitingResponsePlay">@getBtnText(card.card_id)</SpinButton>
                            }
                        </div>
                    </div>
                </div>
            }
        </div>
    }
</div>
</div>

@code {

    [Parameter] // this has to be passed in, because the hand component isn't persistent throughout a game.
    public ResponseCard[] Hand {get;set;} = null;

    [Parameter]
    public int ResponsesRequired {get;set;}

    private List<long> selected {get;set;} = new List<long>();
    private bool hasPlayed = false;

    private string getBtnText(long cardId){
        if (selected.Contains(cardId))
            return "Deselect Card";
        else if (ResponsesRequired == 1)
            return "Play Card";
        else if (selected.Count == ResponsesRequired-1)
            return "Select & Play";
        else
            return "Select Card";
    }

    private string getCardBGCol(long cardId){
        if (selected.Contains(cardId))
            return "lightgrey";
        else
            return "white";
    }

    protected override void OnInitialized(){
        obz.Register<HandUpdatedMessage>("HAND_UPDATED", onHandUpdated, "HandComponent");
        obz.Register<BlankMessage>("RESPONSE_PLAYED", onResponsePlayed, "HandComponent");
        obz.Register<ErrorMessage>("ERR", onServerError, "HandComponent");
        obz.Register<RoundPlayingMessage>("ROUND_PLAYING", onRoundPlaying, "HandComponent");
    }

    private void onHandUpdated(HandUpdatedMessage msg){
        // hand passed in through param
        wagter.SetState("awaitingResponsePlay", false);
    }

    private void onRoundPlaying(RoundPlayingMessage msg){
        this.hasPlayed = false;
    }

    private void onServerError(ErrorMessage msg){
        if (msg.data.info.Contains("already played")){
            this.hasPlayed = true;
            wagter.SetState("awaitingResponsePlay", false);
            base.StateHasChanged();
        }
    }

    private void onResponsePlayed(BlankMessage msg){
        if (wagter.GetState("awaitingResponsePlay")){
            wagter.SetState("awaitingResponsePlay", false);
            this.hasPlayed = true;
            base.StateHasChanged();
        }
    }

    private void OnCardClick(long cardId){
        if (selected.Contains(cardId)){
            selected.Remove(cardId);
        }else if (selected.Count == ResponsesRequired-1){
            
            selected.Add(cardId);
            
            back.SendMessage(new PlayResponseMessage(selected.ToArray()));
            wagter.SetState("awaitingResponsePlay", true);

            selected.Clear();

        }else{

            selected.Add(cardId);

        }

        base.StateHasChanged();
    }

    public void Dispose(){
        obz.Deregister("HandComponent");
    }

}
